View Issue Details

IDProjectCategoryView StatusLast Update
0002625SymmetricDSNew Featurepublic2016-08-09 13:10
ReportermmichalekAssigned Tommichalek 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version3.8.0 
Target Version3.8.0Fixed in Version3.8.0 
Summary0002625: Hybrid Pull Feature
DescriptionIn a SymmetricDS network topology where a server is configured to pull data from thousands of clients, the latency can become greater than desired due to the network overhead of having to connect to a client to see if it has data to pull.

The reason a pull configuration like this might be used (versus the more efficient push configuration) is so the overall network bandwidth usage can be controlled from a central location.

The design allows for the pull configuration, but also includes enhancements for SymmetricDS clients to report their outgoing batch status so that nodes that have data can be prioritized for pulling. The design does require the ability to create an HTTP connection from both the server and the client.
TagsNo tags attached.

Activities

There are no notes attached to this issue.

Related Changesets

SymmetricDS: 3.8 acc67758

2016-07-11 18:20:32

mmichalek

Details Diff
0002625: Hybrid Pull Feature
0002625
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/job/JobManager.java Diff File
add - symmetric-client/src/main/java/org/jumpmind/symmetric/job/ReportStatusJob.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/common/ParameterConstants.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/model/NodeCommunication.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/ClusterConstants.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/IOutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/DataLoaderService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/NodeCommunicationService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/NodeCommunicationServiceSqlMap.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchServiceSqlMap.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/IIncomingTransport.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/file/FileIncomingTransport.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/http/HttpIncomingTransport.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/internal/InternalIncomingTransport.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/web/WebConstants.java Diff File
mod - symmetric-core/src/main/resources/symmetric-default.properties Diff File
mod - symmetric-core/src/main/resources/symmetric-schema.xml Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/PullUriHandler.java Diff File
add - symmetric-server/src/main/java/org/jumpmind/symmetric/web/PushStatusUriHandler.java Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/ServerSymmetricEngine.java Diff File

SymmetricDS: 3.8 2c31eb15

2016-07-12 09:24:48

mmichalek

Details Diff
0002625: Hybrid Pull Feature
0002625
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/NodeCommunicationServiceSqlMap.java Diff File

SymmetricDS: 3.8 2fd3d101

2016-07-21 09:27:16

mmichalek

Details Diff
0002625: Hybrid Pull Feature
0002625
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/job/ReportStatusJob.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/model/RemoteNodeStatus.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/IOutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/DataLoaderService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/NodeCommunicationService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchServiceSqlMap.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/PullService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/ITransportManager.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/http/HttpTransportManager.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/internal/InternalTransportManager.java Diff File
mod - symmetric-core/src/test/java/org/jumpmind/symmetric/transport/MockTransportManager.java Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/PullUriHandler.java Diff File

SymmetricDS: 3.8 414a94df

2016-08-02 14:08:17

mmichalek

Details Diff
0002625: Hybrid Pull Feature
0002625
mod - symmetric-client/src/main/java/org/jumpmind/symmetric/job/ReportStatusJob.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/INodeCommunicationService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/IOutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/DataLoaderService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/NodeCommunicationService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchService.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/service/impl/OutgoingBatchServiceSqlMap.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/ITransportManager.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/TransportUtils.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/http/HttpIncomingTransport.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/http/HttpTransportManager.java Diff File
mod - symmetric-core/src/main/java/org/jumpmind/symmetric/transport/internal/InternalTransportManager.java Diff File
mod - symmetric-core/src/test/java/org/jumpmind/symmetric/transport/MockTransportManager.java Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/PullUriHandler.java Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/PushStatusUriHandler.java Diff File
mod - symmetric-server/src/main/java/org/jumpmind/symmetric/web/ServerSymmetricEngine.java Diff File
mod - symmetric-util/src/main/java/org/jumpmind/util/LogSuppressor.java Diff File

Issue History

Date Modified Username Field Change
2016-06-01 23:39 mmichalek New Issue
2016-06-01 23:39 mmichalek Status new => assigned
2016-06-01 23:39 mmichalek Assigned To => mmichalek
2016-07-11 19:00 mmichalek Changeset attached => SymmetricDS 3.8 acc67758
2016-07-12 10:00 mmichalek Changeset attached => SymmetricDS 3.8 2c31eb15
2016-07-21 10:00 mmichalek Changeset attached => SymmetricDS 3.8 2fd3d101
2016-08-02 15:00 mmichalek Changeset attached => SymmetricDS 3.8 414a94df
2016-08-08 11:13 admin Status assigned => resolved
2016-08-08 11:13 admin Fixed in Version => 3.8.0
2016-08-08 11:13 admin Resolution open => fixed
2016-08-09 13:10 admin Status resolved => closed